unit Unit1;

{-------------------------------------------------------------------------------
 >> Demo 01 de uso da EPL2_Unit <<

        Este demo demonstra como utilizar a unit para gerar script EPL2 de
        impresso de etiquetas, com informaes contidas em um listview.
	O demo est pre-formatado para gerao em rolos de 2 (duas) etiquetas
        lado-a-lado 4,8 x 2,8 cm com espaamento vertical entre etiquetas de
        0,3 cm e sem espaamento horizontal entre etiquetas.
        So impressos 1 cdigo de barras o tipo 128 ABC e 1 texto descritivo
        em cada uma das etiquetas.

        Caso deseje recompilar o programa demo antes de adquirir o fonte da unit,
         necessrio copiar o arquivo EPL2_Unit.dcu para o diretrio Lib de
        instalao do Delphi, no caso do Delphi 6 pro exemplo
        C:\Arquivos de programas\Borland\Delphi6\Lib

        Caso j tenha adquirido a EPL2_Unit registrada, voc pode adiciona-la ao
        seu projeto, clicando em Menu> Project> Add to Project.

 Para remover a mensagem de "No Registrado"  necessrio adquirir a EPL2_Unit
 com fontes. Para informaes sobre como adquirir o produto visite nosso site.

 Atenciosamente,
  Victory Fernandes
   TKS Software
   www.igara.com.br
-------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Printers, ExtCtrls, ShellApi, EPL2_Unit;

type
  TForm1 = class(TForm)
    GroupBox2: TGroupBox;
    Memo1: TMemo;
    Button4: TButton;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    Button5: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label1: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Button3: TButton;
    ListView1: TListView;
    Edit1: TEdit;
    Button1: TButton;
    TabSheet2: TTabSheet;
    GroupBox3: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    CheckBox1: TCheckBox;
    GroupBox4: TGroupBox;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Edit18: TEdit;
    Edit19: TEdit;
    Edit20: TEdit;
    Edit21: TEdit;
    Edit22: TEdit;
    Edit23: TEdit;
    Edit24: TEdit;
    CheckBox5: TCheckBox;
    OpenDialog1: TOpenDialog;
    GroupBox5: TGroupBox;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Edit34: TEdit;
    Edit35: TEdit;
    Edit36: TEdit;
    Edit25: TEdit;
    Edit33: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button6: TButton;
    TabSheet3: TTabSheet;
    GroupBox6: TGroupBox;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit2Enter(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Label29Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

  end;

var
  Form1: TForm1;
  Impressora : Integer;

Type
  TPassThroughData = Record
   nLen : Integer;
   Data : Array[0..2000] of byte;
  end;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
 x: integer;
begin

//--- Impresso de Cdigo de Barras ---
{Impressora de Codigo de Barras Eltron TLP2642 usando linguagem EPL2 em ASCII}
memo1.Lines.Clear;
if strtoint(edit1.text) > 0 then
 begin
  for x:=1 to listview1.Items.Count do
  begin
  Abrir_Etiqueta_EPL2;

  Texto_EPL2(strtoint(edit4.text),                                              //Margem_Esquerda
             strtoint(edit5.text),                                              //Margem_Superior
             strtoint(edit8.text),                                              //Multiplicador_Horizontal
             strtoint(edit9.text),                                              //Multiplicador_Vertical
             'N',                                                               //Tipo_Fonte
             copy(listview1.Items.Item[x-1].SubItems.Strings[0],0,25),          //Texto
             CheckBox1.Checked,                                                 //Imprime_Espelhado
             StrToInt(edit6.Text));                                             //Rotacao

  Codigo_Barras_EPL2(StrToInt(edit18.Text),                                     //margem_Esquerda
                     StrToInt(edit19.Text),                                     //margem_Superior
                     StrToInt(edit22.Text),                                     //Barra_Fina
                     StrToInt(edit23.Text),                                     //Barra_Grossa
                     StrToInt(edit24.Text),                                     //Altura_Barra
                     edit21.text,                                               //Tipo_Codigo
                     listview1.Items.Item[x-1].Caption,                         //Texto
                     CheckBox5.Checked,                                         //Imprime_Numero
                     StrToInt(edit20.Text));                                    //Rotacao

  memo1.Lines.AddStrings(Fechar_Etiqueta_EPL2(false, StrToInt(edit1.Text)));
 end;
 end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 //impressao do codigo de barras
 if memo1.Lines.Count > 0 then
  begin
   Printer.BeginDoc;
   Impressao_paralela(memo1.Lines.Text);
   Printer.EndDoc;
  end;
end;

procedure TForm1.Edit2Enter(Sender: TObject);
begin
//Altera cor de edit
TEdit(sender).color := claqua;
end;

procedure TForm1.Edit2Exit(Sender: TObject);
begin
//Altera cor de edit
TEdit(sender).color := clwindow;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
//Aceita apenas caracteres numericos
if not (key in ['0','1','2','3','4','5','6','7','8','9',#32,#08]) then
 key := #0;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
 i: integer;
begin
//adiciona item a lista
if (trim(edit2.text) <> '') and
   (trim(edit3.text) <> '') then
 begin
  with ListView1.Items do
   begin
    i := Count;
    Insert(i);
    Item[i].Caption := edit2.text;
    Item[i].SubItems.Insert( 0, edit3.text);
   end;
 end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 //Salva arquivo de Script de Impressao
 if memo1.Lines.Count > 0 then
  begin
   savedialog1.InitialDir := extractfiledir(Application.ExeName);
   if savedialog1.Execute then
    memo1.Lines.SaveToFile(savedialog1.FileName);
  end;
end;

procedure TForm1.ListView1DblClick(Sender: TObject);
begin
 //exclui item da lista
 if listview1.ItemIndex <> -1 then
  listview1.Items.Delete(listview1.ItemIndex);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 //Abre arquivo de Script de Impressao
 opendialog1.InitialDir := extractfiledir(Application.ExeName);
 if opendialog1.Execute then
  memo1.Lines.loadfromFile(opendialog1.FileName);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 //formatacao da etiqueta p/ impressao do codigo de barras
 Abrir_Etiqueta_EPL2;

 Configura_EPL2(StrToInt(edit34.Text),         //Comprimento_Etiqueta
                StrToInt(edit35.Text),         //Distancia_Etiqueta
                StrToInt(edit36.Text),         //Offset
                StrToInt(edit25.Text),         //Margem_Horizontal
                StrToInt(edit33.Text));        //Margem_Vertical

 memo1.Lines:= Fechar_Etiqueta_EPL2(false, StrToInt(edit1.Text));
end;

procedure TForm1.Label29Click(Sender: TObject);
begin
 ShellExecute(Self.Handle, nil, PChar(TLabel(sender).caption), nil, nil, SW_NORMAL);
end;

end.
